
(* For running the thing from toplevel; probably an exportable
   main () eventually.  - Tom 7 *)

structure Top =
struct

  exception Done

  fun parseFile fileName : Il.exp = 
      ToTree.totree ( (Tokenize.tokenize (FStream.fstream (TextIO.openIn fileName))))
	handle e as Tokenize.ParseError s => (print s; print "\n"; raise e)
	     | e => (print "Error in parseFile\n"; raise e)
	    
    fun parsestring s =
	( (Tokenize.tokenize (SStream.sstream s)))
	handle e as Tokenize.ParseError s => 
	    let in
		print s; 
		print "\n";
		raise e
	    end

    fun run _ =
      let
        val secs = 
	  (case Params.docommandline () of
            nil => 179
          | [i] => Option.getOpt (Int.fromString i, 179)) 
            handle _ =>
              let in
                print "this program takes one or no arguments. usage:\n";
		print (Params.usage ());
                raise Done
              end
        val timer = Timer.startRealTimer ()
        val tree =  (Tokenize.tokenize (FStream.stdin ()))
      in
        Driver.optimize {timer=timer, seconds=secs, exp=tree}
      end

end
